> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.withpersona.com/2025-12-08/api-reference/devices/list-all-devices/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.withpersona.com/_mcp/server. # List all Devices GET https://api.withpersona.com/api/v1/devices Retrieves a list of Devices. Results are returned in reverse chronological order, with the most recently created objects first. Reference: https://docs.withpersona.com/api-reference/devices/list-all-devices ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Query parameters - `filter` (DevicesGetParametersFilter, required) ### Headers - `Key-Inflection` (enum, optional) — Determines casing for the API response. - Allowed values: `camel`, `kebab`, `snake` - `Idempotency-Key` (string, optional) — Ensures the request is idempotent. - `Persona-Version` (enum, optional) — Server API version. More info on versioning can be found [here](https://docs.withpersona.com/versioning). - Allowed values: `2025-12-08`, `2025-10-27`, `2023-01-05`, `2022-09-01`, `2021-08-18`, `2021-07-05`, `2021-02-21`, `2020-05-18` ## Response ### 200 This endpoint returns a collection of Device objects. - `data` (list of device, required) - `links` (DevicesGetResponsesContentApplicationJsonSchemaLinks, required) ## Errors ### 400 Bad Request Error The request was unacceptable, often due to invalid parameters. - `errors` (list of DevicesGetResponsesContentApplicationJsonSchemaErrorsItems, optional) ### 401 Unauthorized Error An invalid API key was provided. - `errors` (list of DevicesGetResponsesContentApplicationJsonSchemaErrorsItems, optional) ### 403 Forbidden Error The given API key doesn’t have permissions to perform the request or a quota has been exceeded. - `errors` (list of DevicesGetResponsesContentApplicationJsonSchemaErrorsItems, optional) ### 429 Too Many Requests Error Your organization’s rate limit has been exceeded. We recommend an exponential backoff on requests. - `errors` (list of DevicesGetResponsesContentApplicationJsonSchemaErrorsItems, optional) ### 503 Service Unavailable Error Something went wrong on Persona’s end. These are rare. - `errors` (list of DevicesGetResponsesContentApplicationJsonSchemaErrorsItems, optional) ## Types ### DevicesGetParametersFilter - `inquiry-session-id` (string, required) — Filter devices by inquiry session ID ### device - `id` (string, optional) — Unique identifier for this Device. Starts with `dev_`. - `attributes` (InquirySessionsIncludedObjectsItemsDiscriminatorMappingDeviceAttributes, optional) ### DevicesGetResponsesContentApplicationJsonSchemaLinks - `prev` (string, required, nullable) - `next` (string, required, nullable) ### DevicesGetResponsesContentApplicationJsonSchemaErrorsItems - `title` (string, optional) — Service unavailable - `details` (string, optional) ### InquirySessionsIncludedObjectsItemsDiscriminatorMappingDeviceAttributes - `device-vendor-id` (string, optional, nullable) - `device-fingerprint` (string, optional, nullable) - `browser-fingerprint` (string, optional, nullable) ## Examples **Response** ```json { "data": [ { "id": "dev_ABC123", "attributes": { "device-vendor-id": "1a2b3c4d-5e6f-7g8h-9ijk-1A2B3C4D5E6F", "device-fingerprint": "1a2b3c4d5e6f7g8h9ijk", "browser-fingerprint": "1a2b3c4d5e6f7g8h9ijklmnopqrstuvw" }, "type": "device" } ], "links": { "prev": null, "next": null } } ``` **SDK Code** ```python Success import requests url = "https://api.withpersona.com/api/v1/devices" querystring = {"filter":"{\"inquiry-session-id\":\"iqse_ABC123\"}"} headers = {"Authorization": "Bearer "} response = requests.get(url, headers=headers, params=querystring) print(response.json()) ``` ```javascript Success const url = 'https://api.withpersona.com/api/v1/devices?filter=%7B%22inquiry-session-id%22%3A%22iqse_ABC123%22%7D'; const options = {method: 'GET', headers: {Authorization: 'Bearer '}}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go Success package main import ( "fmt" "net/http" "io" ) func main() { url := "https://api.withpersona.com/api/v1/devices?filter=%7B%22inquiry-session-id%22%3A%22iqse_ABC123%22%7D" req, _ := http.NewRequest("GET", url, nil) req.Header.Add("Authorization", "Bearer ") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby Success require 'uri' require 'net/http' url = URI("https://api.withpersona.com/api/v1/devices?filter=%7B%22inquiry-session-id%22%3A%22iqse_ABC123%22%7D") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Get.new(url) request["Authorization"] = 'Bearer ' response = http.request(request) puts response.read_body ``` ```java Success import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.get("https://api.withpersona.com/api/v1/devices?filter=%7B%22inquiry-session-id%22%3A%22iqse_ABC123%22%7D") .header("Authorization", "Bearer ") .asString(); ``` ```php Success request('GET', 'https://api.withpersona.com/api/v1/devices?filter=%7B%22inquiry-session-id%22%3A%22iqse_ABC123%22%7D', [ 'headers' => [ 'Authorization' => 'Bearer ', ], ]); echo $response->getBody(); ``` ```csharp Success using RestSharp; var client = new RestClient("https://api.withpersona.com/api/v1/devices?filter=%7B%22inquiry-session-id%22%3A%22iqse_ABC123%22%7D"); var request = new RestRequest(Method.GET); request.AddHeader("Authorization", "Bearer "); IRestResponse response = client.Execute(request); ``` ```swift Success import Foundation let headers = ["Authorization": "Bearer "] let request = NSMutableURLRequest(url: NSURL(string: "https://api.withpersona.com/api/v1/devices?filter=%7B%22inquiry-session-id%22%3A%22iqse_ABC123%22%7D")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "GET" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```